#!/usr/bin/python
# -*- coding: utf-8 -*-
#
# Pyromaths
# Un programme en Python qui permet de créer des fiches d'exercices types de
# mathématiques niveau collège ainsi que leur corrigé en LaTeX.
# Copyright (C) 2006 -- Jérôme Ortais (jerome.ortais@pyromaths.org)
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
#

import outils
from fonctions_globales import OperateurPrioritaire, Affichage
import random
from pyro_classes import Fractions


import gettext
import locale
locale.setlocale(locale.LC_ALL, "")
locale.textdomain("pyromaths")
gettext.textdomain("pyromaths")
_=locale.gettext

def sommes_fractions_4e():
    while True:
        op = ["+", "-"][random.randrange(2)]
        (n1, d1, n2, d2) = (2, 2, 2, 2)
        while True:
            n1 = outils.valeur_alea(-16, 16)
            d1 = -outils.valeur_alea(-40, 40)
            n2 = outils.valeur_alea(-16, 16)
            d2 = outils.valeur_alea(-40, 40)
            fr1 = Fractions(n1, d1)
            fr2 = Fractions(n2, d2)
            if outils.pgcd(n1, d1) == 1 and outils.pgcd(n2, d2) == 1 and \
                outils.pgcd(d1, d2) != abs(d1) and outils.pgcd(d1, d2) != \
                abs(d2):
                if op == "+":
                    simplifiable = abs(fr1.d * fr2.d) != abs(Fractions.simplifie(fr1 +
                            fr2).d)
                else:
                    simplifiable = abs(fr1.d * fr2.d) != abs(Fractions.simplifie(fr1 -
                            fr2).d)
                if simplifiable:
                    break
        l = [fr1, op, fr2]
        (cor, res, niveau) = OperateurPrioritaire(l, 4, solution=[])
        if niveau >= 4:
            break
    return ([Fractions(n1, d1), op, Fractions(n2, d2)], cor, res)


def produits_fractions_4e():
    while True:
        op = ["*", "/"][random.randrange(2)]
        (n1, d1, n2, d2) = (2, 2, 2, 2)
        while True:
            n1 = outils.valeur_alea(-16, 16)
            d1 = -outils.valeur_alea(-40, 40)
            n2 = outils.valeur_alea(-16, 16)
            d2 = outils.valeur_alea(-40, 40)
            fr1 = Fractions(n1, d1)
            fr2 = Fractions(n2, d2)
            if outils.pgcd(n1, d1) == 1 and outils.pgcd(n2, d2) == 1 and \
                outils.pgcd(d1, d2) != abs(d1) and outils.pgcd(d1, d2) != \
                abs(d2):
                if op == "*":
                    simplifiable = abs(fr1.d * fr2.d) != Fractions.simplifie(fr1 *
                            fr2).d
                else:
                    simplifiable = abs(fr1.d * fr2.n) != Fractions.simplifie(fr1 /
                            fr2).d
                if simplifiable:
                    break
        l = [Fractions(n1, d1), op, Fractions(n2, d2)]

        (cor, res, niveau) = OperateurPrioritaire(l, 4, solution=[])
        if niveau >= 4:
            break
    return (l, cor, res)


def valeurs_priorites_fractions(nb, entier=1):  # renvoie les 2 listes contenant les opérateurs et les opérandes.
    listoperateurs = [
        "+",
        "*",
        "-",
        "/",
        '(',
        '(',
        '(',
        '(',
        ')',
        ')',
        ')',
        ')',
        ]
    loperateurs = []
    loperandes = []
    i = 0  #nombre d'opérateurs créés
    p = 0  #nombre de parenthèses ouvertes
    cpt = 0  #compteur pour éviter que le programme ne boucle.
    while i < nb - 1:
        cpt = cpt + 1
        if cpt > 10:  #On recommence
            (cpt, i, p, loperateurs) = (0, 0, 0, [])
        if p:
            if loperateurs[-1] == '(':  # On n'écrit pas 2 parenthèses à suivre
                operateur = listoperateurs[random.randrange(4)]
            else:
                operateur = listoperateurs[random.randrange(12)]
        elif loperateurs == []:

            # On ne commence pas par une parenthèse

            operateur = listoperateurs[random.randrange(4)]
        else:
            operateur = listoperateurs[random.randrange(8)]
        if nb > 3:
            test = ('-*/').find(operateur) >= 0 and loperateurs.count(operateur) < \
                1 or operateur == "+" and loperateurs.count(operateur) < \
                2
        else:
            test = ('-*/+').find(operateur) >= 0 and loperateurs.count(operateur) < \
                1
        if test:

            #On n'accepte pas plus de 1 produit, différence, quotient et de 2 sommes ou parenthèses par calcul.

            if i == 0 or loperateurs[-1] != '(' or ('*/').find(operateur) < \
                0:  #pas de * ou / dans une parenthèse.
                i = i + 1
                loperateurs.append(operateur)
        elif operateur == '(' and (')+').find(loperateurs[-1]) < 0:

            #Il ne peut y avoir de ( après une ) ou après un +

            p = p + 1
            loperateurs.append(operateur)
        elif operateur == ')':
            p = p - 1
            loperateurs.append(operateur)
    while p > 0:
        loperateurs.append(')')
        p = p - 1
    loperandes = []
    for i in xrange(nb):
        (n, d) = (2, 2)
        while outils.pgcd(n, d) != 1 or abs(d) == 1:
            n = outils.valeur_alea(-16, 16)
            d = -outils.valeur_alea(-40, 40)
        loperandes.append(Fractions(n, d))
    exercice = [loperandes[0]]
    i = 1
    j = 0
    while i < len(loperandes) or j < len(loperateurs):
        if j < len(loperateurs):
            exercice.append(loperateurs[j])
            j = j + 1
        while j < len(loperateurs) and (loperateurs[j] == '(' or
                loperateurs[j - 1] == ')'):
            exercice.append(loperateurs[j])
            j = j + 1
        if i < len(loperandes):
            exercice.append(loperandes[i])
            i = i + 1
    return exercice


def exo_sommes_fractions():
    exo = ["\\exercice",
           _("Effectuer les calculs suivants et donner le r\\'esultat sous la forme d'une fraction simplifi\\'ee :"),
           "\\begin{multicols}{4}", "  \\noindent%"]
    cor = ["\\exercice*",
           _("Effectuer les calculs suivants et donner le r\\'esultat sous la forme d'une fraction simplifi\\'ee :"),
           "\\begin{multicols}{4}", "  \\noindent%"]
    for i in xrange(8):
        (l, sol, res) = sommes_fractions_4e()
        exo.append("  \\[\\thenocalcul = %s\\]" % Affichage(l))
        cor.append("  \\[\\thenocalcul = %s\\]" % Affichage(l))
        for l in sol:
            if l == sol[-1]:
                cor.append("  \\[\\boxed{\\thenocalcul = %s}\\]" % l)
            else:
                cor.append("  \\[\\thenocalcul = %s\\]" % l)
        exo.append("  \\stepcounter{nocalcul}%")
        cor.append("  \\stepcounter{nocalcul}%")
    exo.append("\\end{multicols}\n")
    cor.append("\\end{multicols}\n")
    return (exo, cor)


def exo_produits_fractions():
    exo = ["\\exercice",
           _("Effectuer les calculs suivants et donner le r\\'esultat sous la forme d'une fraction simplifi\\'ee :"),
           "\\begin{multicols}{4}", "  \\noindent%"]
    cor = ["\\exercice*",
           _("Effectuer les calculs suivants et donner le r\\'esultat sous la forme d'une fraction simplifi\\'ee :"),
           "\\begin{multicols}{4}", "  \\noindent%"]
    for i in xrange(8):
        (l, sol, res) = produits_fractions_4e()
        exo.append("  \\[\\thenocalcul = %s\\]" % Affichage(l))
        cor.append("  \\[\\thenocalcul = %s\\]" % Affichage(l))
        for l in sol:
            if l == sol[-1]:
                cor.append("  \\[\\boxed{\\thenocalcul = %s}\\]" % l)
            else:
                cor.append("  \\[\\thenocalcul = %s\\]" % l)
        exo.append("  \\stepcounter{nocalcul}%")
        cor.append("  \\stepcounter{nocalcul}%")
    exo.append("\\end{multicols}\n")
    cor.append("\\end{multicols}\n")
    return (exo, cor)


def exo_priorites_fractions():
    exo = ["\\exercice",
           _("Effectuer les calculs suivants et donner le r\\'esultat sous la forme d'une fraction simplifi\\'ee :"),
           "\\begin{multicols}{3}", "  \\noindent%"]
    cor = ["\\exercice*",
           _("Effectuer les calculs suivants et donner le r\\'esultat sous la forme d'une fraction simplifi\\'ee :"),
           "\\begin{multicols}{3}", "  \\noindent%"]
    for i in xrange(6):
        while True:
            l = valeurs_priorites_fractions(3)
            (sol, res, niveau) = OperateurPrioritaire(l, 4, solution=[])
            if niveau >= 4:
                break
        exo.append("  \\[\\thenocalcul = %s\\]" % Affichage(l))
        cor.append("  \\[\\thenocalcul = %s\\]" % Affichage(l))
        for l in sol:
            if l == sol[-1]:
                cor.append("  \\[\\boxed{\\thenocalcul = %s}\\]" % l)
            else:
                cor.append("  \\[\\thenocalcul = %s\\]" % l)
        exo.append("  \\stepcounter{nocalcul}%")
        cor.append("  \\stepcounter{nocalcul}%")
    exo.append("\\end{multicols}\n")
    cor.append("\\end{multicols}\n")
    return (exo, cor)


